import levenshtein, { levenshteinDistance } from './levenshtein';
import lcs, { lcslen } from './lcs';
import { simhash, hammingDistance, hammingWeight, similarity as simhashSimilarity, SimhashOptions, SimhashSimilarityReturn } from './simhash';
export { levenshtein, levenshteinDistance, lcs, lcslen, simhash, hammingDistance, hammingWeight, simhashSimilarity };
declare type Type = 'lcs' | 'levenshtein' | 'simhash';
declare type SimilarityReturn = number | SimhashSimilarityReturn;
export default function similarity(x: string, y: string, type?: Type, options?: SimhashOptions): SimilarityReturn;
